## pure-faust-0.10.tar.gz

=== Makefile ===

# Package name and version number:
dist = pure-faust-$(version)
version = 0.10

# compiler flags -- these can be overridden from the command line if needed,
# as well as CPPFLAGS, LDFLAGS and LIBS
CFLAGS = -O3
#CFLAGS = -g -O2

# platform-specific setup

DLL         = $(shell pkg-config pure --variable DLL)
PIC         = $(shell pkg-config pure --variable PIC)
shared      = $(shell pkg-config pure --variable shared)

prefix      = $(shell pkg-config pure --variable prefix)
bindir      = $(prefix)/bin
libdir      = $(shell pkg-config pure --variable libdir)

ifeq ($(DLL),.dylib)
# OSX: hardcode the installation path into the module, so that the module can
# be linked in by the batch compiler.
dllname = -install_name "$(libdir)/pure/$@"
endif

MOD_CFLAGS  = $(PIC) $(shell pkg-config pure --cflags) $(CFLAGS) $(CPPFLAGS)
MOD_LDFLAGS = $(shell pkg-config pure --libs) $(LDFLAGS) $(LIBS)

DISTFILES = COPYING COPYING.LESSER Makefile README \
faust.cc faust.pure faust2.pure \
debian/* examples/Makefile examples/pure.c examples/pure.cpp \
examples/*.pure examples/*.dsp
SEDFILES = README

all: faust$(DLL)

faust$(DLL): faust.o
	$(CXX) $(shared) $(dllname) -o $@ $< $(MOD_LDFLAGS) -lltdl

faust.o: faust.cc
	$(CXX) $(MOD_CFLAGS) -o $@ -c $<

clean:
	rm -Rf faust$(DLL)* *~ *.a *.o

install:
	test -d "$(DESTDIR)$(libdir)/pure" || mkdir -p "$(DESTDIR)$(libdir)/pure"
	cp faust$(DLL) faust.pure faust2.pure "$(DESTDIR)$(libdir)/pure"

uninstall:
	rm -f "$(DESTDIR)$(libdir)/pure"/faust$(DLL) "$(DESTDIR)$(libdir)/pure"/faust.pure "$(DESTDIR)$(libdir)/pure"/faust2.pure

date = $(shell date "+%B %-d, %Y")
datesubst = sed -e "s?@version@?$(version)?g" -e "s?|today|?$(date)?g" < $(1) > $(2)

dist:
	rm -rf $(dist)
	mkdir $(dist) && mkdir $(dist)/debian && mkdir $(dist)/examples
	for x in $(DISTFILES); do ln -sf $$PWD/$$x $(dist)/$$x; done
	for x in $(SEDFILES); do rm -f $(dist)/$$x; $(call datesubst,$$PWD/$$x,$(dist)/$$x); done
	rm -f $(dist).tar.gz
	tar cfzh $(dist).tar.gz $(dist)
	rm -rf $(dist)

distcheck: dist
	tar xfz $(dist).tar.gz
	cd $(dist) && make && make install DESTDIR=./BUILD
	rm -rf $(dist)

debsrc = $(shell echo $(dist) | sed -e 's/-$(version)/_$(version)/').orig.tar.gz

deb: $(debsrc) dist
	tar xfz $(dist).tar.gz
	cd $(dist) && debuild $(DEBUILD_FLAGS)
	rm -rf $(dist)

$(debsrc):
	wget -nv https://bitbucket.org/purelang/pure-lang/downloads/$(dist).tar.gz -O $@

=== examples/Makefile ===

# Generic Makefile for Pure-Faust plugins.

# make, make all: make plugins
# make bitcode: make plugins in LLVM bitcode format
# make cpp: make C++ sources
# make svg: make SVG diagrams
# make clean: remove all generated stuff

# Platform-specific defaults, edit this as needed.
#PIC = -fPIC # uncomment for x86-64 compilation
DLL = .so
shared = -shared

CXXFLAGS = -g -O2

# Try to guess the host system type and figure out compilation flags.
host = $(shell ../config.guess)
ifneq "$(findstring -mingw,$(host))" ""
# Windows
DLL = .dll
endif
ifneq "$(findstring -darwin,$(host))" ""
# OSX (untested)
DLL = .dylib
shared = -dynamiclib
endif
ifneq "$(findstring x86_64-,$(host))" ""
# 64 bit, needs -fPIC flag
PIC = -fPIC
endif

dspsrc  := $(wildcard *.dsp)
cppsrc  := $(dspsrc:.dsp=.cpp)
plugins	:= $(dspsrc:.dsp=$(DLL))
bitcode	:= $(dspsrc:.dsp=.bc)
svg 	:= $(dspsrc:.dsp=-svg)
xml 	:= $(dspsrc:.dsp=.dsp.xml)

all: $(plugins)
cpp: $(cppsrc)
svg: $(svg)
xml: $(xml)

# Use this target to generate bitcode modules (this requires faust2).
bitcode: $(bitcode)

clean:
	rm -Rf *~ $(cppsrc) $(plugins) $(bitcode) $(svg) $(xml)

%.cpp: %.dsp
	faust -a pure.cpp -double $< -o $@

%$(DLL): %.cpp
	$(CXX) $(shared) $(PIC) $(CPPFLAGS) $(CXXFLAGS) $(LDFLAGS) -o $@ $<

# Here's an alternative rule which shows how to create bitcode using the C
# architecture pure.c instead. You'll need an LLVM-capable C compiler like
# clang for this.
%.bc: %.dsp
	faust -lang c -a pure.c -double $< -o $(<:.dsp=.c)
	clang -emit-llvm -O3 -c $(<:.dsp=.c) -o $@
	rm -f $(<:.dsp=.c)

# Default rule for generating bitcode directly using Faust.
%.bc: %.dsp
	faust -lang llvm -double $< -o $@

%-svg: %.dsp
	faust -svg $< -o /dev/null

%.dsp.xml: %.dsp
	faust -xml $< -o /dev/null

=== debian/changelog ===
pure-faust (0.9-3) precise; urgency=low

  * Faust2 compatibility

 -- Albert Graef <Dr.Graef@t-online.de>  Fri, 18 Jan 2013 15:11:30 +0100

pure-faust (0.9-2) natty; urgency=low

  * Prevent zipping of examples

 -- Albert Graef <Dr.Graef@t-online.de>  Sat, 26 May 2012 23:39:35 +0200

pure-faust (0.9-1) natty; urgency=low

  * Initial release

 -- Albert Graef <Dr.Graef@t-online.de>  Thu, 24 May 2012 20:55:41 +0200

=== debian/control ===
Source: pure-faust
Section: devel
Priority: extra
Maintainer: Albert Graef <aggraef@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), pure-dev, libltdl-dev
Standards-Version: 3.9.1
Homepage: http://purelang.bitbucket.org

Package: pure-faust
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: faust (>> 0.9.46) | faust2
Description: Faust interface for the Pure programming language
 Pure is a modern-style functional programming language based on term
 rewriting. This package provides a module which lets you load and run
 Faust-generated signal processing modules in Pure. Faust is a functional
 programming language for real-time sound processing and synthesis developed
 at Grame (http://faust.grame.fr).
 .
 Note that as of version 0.5 pure-faust also comes with a compatibility module
 which provides the pure-faust API on top of Pure's built-in Faust interface,
 please see the included README file or the Pure documentation for details.

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

https://bitbucket.org/purelang/pure-lang/downloads/pure-faust-(.*)\.tar\.gz
